package kaysaar.aotd_question_of_loyalty.data.scripts.rulesInterceptor;

import java.util.Iterator;
import java.util.List;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import kaysaar.aotd_question_of_loyalty.data.scripts.commision.FactionHatredManager;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import com.fs.starfarer.api.Global;

public class CommisionReplaceScript extends BaseReplaceScript
{
    @Override
    public void advance(final float amount) {
        if (Global.getSector().getCampaignUI().isShowingDialog()) {
            final InteractionDialogAPI dialog = Global.getSector().getCampaignUI().getCurrentInteractionDialog();
            if (dialog != null) {
                if (dialog.getOptionPanel().hasOption((Object)"cmsn_askCommission") && !this.isInInteraction) {
                    this.isInInteraction = true;
                    dialog.getOptionPanel().removeOption((Object)"cmsn_askCommission");
                    final List list = dialog.getOptionPanel().getSavedOptionList();
                    dialog.getOptionPanel().clearOptions();
                    dialog.getOptionPanel().addOption("I would like to be commissioned by " + dialog.getInteractionTarget().getActivePerson().getFaction().getDisplayName(), (Object)"aotd_cmsn_askCommission", AoTDCommIntelPlugin.optionColor, (String)null);
                    final List list2 = dialog.getOptionPanel().getSavedOptionList();
                    final Object obj = list2.get(0);
                    final List list3 = dialog.getOptionPanel().getSavedOptionList();
                    list3.clear();
                    dialog.getOptionPanel().clearOptions();
                    int i = 0;
                    for (final Object o : list) {
                        if (i == 1) {
                            list3.add(obj);
                        }
                        list3.add(o);
                        ++i;
                    }
                    dialog.getOptionPanel().restoreSavedOptions(list3);
                    dialog.getOptionPanel().setEnabled((Object)"aotd_cmsn_askCommission", !QoLMisc.isCommissioned());
                    dialog.getOptionPanel().setShortcut(list3.get(list3.size() - 1), 1, false, false, false, true);
                    if (FactionHatredManager.get().doesFactionHatePlayer(dialog.getInteractionTarget().getFaction().getId())) {
                        dialog.getOptionPanel().setEnabled((Object)"aotd_cmsn_askCommission", false);
                        if (FactionHatredManager.get().getRebellions() >= FactionHatredManager.maxRebellions) {
                            dialog.getOptionPanel().setTooltip((Object)"aotd_cmsn_askCommission", "Due to your backstabbing previous commissioners none of factions trust you anymore!");
                        }
                        else {
                            dialog.getOptionPanel().setTooltip((Object)"aotd_cmsn_askCommission", "Due to our actions this faction won't ever commissions us again!");
                        }
                    }
                }
                else if (!dialog.getOptionPanel().hasOption((Object)"aotd_cmsn_askCommission")) {
                    this.isInInteraction = false;
                }
            }
        }
        else {
            this.isInInteraction = false;
        }
    }
}
